'gbWinSpy Gary Beene
#Compile Exe
#Dim All
#Debug Error On     'catch array/pointer errors - OFF in production
#Debug Display On   'display untrapped errors   - OFF in production
#Include "Win32api.inc"
#Include "CommCtrl.inc"
#Resource "gbwinspy.pbr"

'Dialog Control Equates ========================================================
%IDC_ListViewStyle     = 300
%IDC_ListViewXStyle    = 301
%IDC_Label             = 302
%IDC_LabelStyle        = 303
%IDC_LabelXStyle       = 304
%IDC_StyleString       = 305
%IDC_StringToHex       = 306
%IDC_StyleValue        = 307
%IDC_xStyleString      = 308
%IDC_StringToXHex      = 309
%IDC_xStyleValue       = 310
%IDC_Convert           = 311
%IDC_xConvert          = 312
%IDC_Spy               = 313

'Menu Equates ========================================================
%IDM_Dialog            = 400
%IDM_Button            = 401
%IDM_Check3State       = 402
%IDM_CheckBox          = 403
%IDM_ComboBox          = 404
%IDM_Frame             = 405
%IDM_Graphic           = 406
%IDM_Image             = 407
%IDM_ImageX            = 408
%IDM_ImgButton         = 409
%IDM_ImgButtonX        = 410
%IDM_Label             = 411
%IDM_Line              = 412
%IDM_ListBox           = 413
%IDM_ListView          = 414
%IDM_Option            = 415
%IDM_ProgressBar       = 416
%IDM_HScrollBar        = 417
%IDM_VScrollBar        = 418
%IDM_StatusBar         = 419
%IDM_Tab               = 420
%IDM_TextBox           = 421
%IDM_Toolbar           = 422
%IDM_TreeView          = 423

%IDM_DisplayStyle      = 450
%IDM_DisplayXStyle     = 451
%IDM_ClearStyle        = 452
%IDM_ClearXStyle       = 453
%IDM_ClearAll          = 454
%IDM_MatchStyles       = 455
%IDM_MatchXStyles      = 456
%IDM_Sep               = 457
%IDM_Cut               = 458
%IDM_Copy              = 459
%IDM_Paste             = 460
%IDM_Delete            = 461


Global hDlg, hAction, hMenu, hLVStyle, hLVXStyle, hControl, hContext, hCurrentTextBox As Dword
Global StyleListName(), xStyleListName(), cNames(), cPrefix()  As String
Global StyleListValue(), xStyleListValue() As Long
Global OP1, OP2, OP3, OP4, hTB1, hTB2, hTB3, hTB4, CurrentControlType As Long

Function PBMain()
  Dialog New Pixels, 0, "gbWinSpy",400,400,600,450, %WS_OverlappedWindow, 0 To hDlg
  Dialog Set Icon hDlg, "stylist"
  LoadcNames
  BuildMenu
  BuildControls
  CreateTooltips
  Dialog Show Modal hDlg Call PropertyProc
End Function

CallBack Function PropertyProc() As Long
   Local i, iStyle, iXStyle As Long, temp$
   Local LVH As LV_HITTESTINFO, pt As PointAPI, iResult As Long
   Select Case Cb.Msg
      Case %WM_InitDialog
         Settings_INI "get"
         LoadStyleList

         temp$ = GetCompositeStyleString(iStyle)
         Control Set Text hDlg, %IDC_StyleString, temp$
         Control Set Text hDlg, %IDC_StyleValue,  "&H" + Hex$(iStyle)

         temp$ = GetCompositeXStyleString(iXStyle)
         Control Set Text hDlg, %IDC_XStyleString, temp$
         Control Set Text hDlg, %IDC_XStyleValue,  "&H" + Hex$(iXStyle)

      Case %WM_Destroy
         Settings_INI "save"

      Case %WM_Command
         Select Case Cb.Ctl
             Case %IDC_Spy
                 MsgBox "Hi, I don't do anything yet. I'm just reserving a space for future gbWinSpy features!", %MB_Ok + %MB_IconInformation, "gbWinSpy"
             Case %IdOk
                 Select Case GetFocus
                     Case hTB1 : MatchStyles
                     Case hTB2 : MatchXStyles
                     Case hTB3
                        Control Get Text hDlg, %IDC_StyleValue To temp$
                        ConvertStyleLongToString(temp$)
                        Control Set Text hDlg, %IDC_StyleString, temp$
                        MatchStyles
                     Case hTB4
                        Control Get Text hDlg, %IDC_XStyleValue To temp$
                        ConvertXStyleLongToString (temp$)
                        Control Set Text hDlg, %IDC_XStyleString, temp$
                        MatchXStyles
                 End Select
             Case %IDM_DisplayStyle, %IDC_LabelStyle
                 Control Get Text hDlg, %IDC_StyleString To temp$
                 Replace " OR " With $CrLf In Temp$
                 Replace " or " With $CrLf In Temp$
                 MsgBox temp$, %MB_Ok + %MB_IconInformation, "Style"

             Case %IDM_DisplayXStyle, %IDC_LabelXStyle
                 Control Get Text hDlg, %IDC_XStyleString To temp$
                 Replace " OR " With $CrLf In Temp$
                 Replace " or " With $CrLf In Temp$
                 MsgBox temp$, %MB_Ok + %MB_IconInformation, "XStyle"

             Case %IDM_ClearStyle   : ClearCheckMarks(0)
             Case %IDM_ClearXStyle  : ClearCheckmarks(1)
             Case %IDM_ClearAll     : ClearCheckmarks(2)

             Case %IDM_MatchStyles  : MatchStyles
             Case %IDM_MatchxStyles : MatchxStyles

            Case 400 To 423
                For i = 400 To 423 : Menu Set State hControl, ByCmd i, 0 : Next i
                CurrentControlType = Cb.Ctl
                Menu Set State hControl, ByCmd CurrentControlType, 8

             Case %IDC_StringToHex
                 Control Get Text hDlg, %IDC_StyleString To temp$
                 iStyle = ConvertStyleStringToLong(temp$)
                 Control Set Text hDlg, %IDC_StyleValue, "&H" + Hex$(iStyle)
'                 MatchStyles

             Case %IDC_StringToXHex
                 Control Get Text hDlg, %IDC_XStyleString To temp$
                 iXStyle = ConvertXStyleStringToLong(temp$)
                 Control Set Text hDlg, %IDC_xStyleValue, "&H" + Hex$(iXStyle)
                 MatchXStyles

             Case %IDC_Convert
                 Control Get Text hDlg, %IDC_StyleValue To temp$
                 ConvertStyleLongToString(temp$)
                 Control Set Text hDlg, %IDC_StyleString, temp$
                 MatchStyles

             Case %IDC_xConvert
                 Control Get Text hDlg, %IDC_XStyleValue To temp$
                 ConvertXStyleLongToString(temp$)
                 Control Set Text hDlg, %IDC_xStyleString, temp$
                 MatchXStyles

             Case %IDM_Cut    : SendMessage hCurrentTextBox, %WM_Cut, 0,0
             Case %IDM_Copy   : SendMessage hCurrentTextBox, %WM_Copy, 0,0
             Case %IDM_Paste  : SendMessage hCurrentTextBox, %WM_Paste, 0,0
             Case %IDM_Delete : SendMessage hCurrentTextBox, %WM_Clear, 0,0
          End Select

      Case %WM_Size : ResizeWindow
      Case %WM_Notify
          Select Case Cb.NmId
              Case %IDC_ListViewStyle
                  Select Case Cb.NmCode
                      Case %LVN_ColumnClick
                          ClearCheckmarks(0)
                          temp$ = GetCompositeStyleString(iStyle)
                          Control Set Text hDlg, %IDC_StyleString, temp$
                          Control Set Text hDlg, %IDC_StyleValue,  "&H" + Hex$(iStyle)
                      Case %LVN_ItemChanged
                          GetCursorPos PT
                          ScreenToClient hLVStyle, PT
                          lvh.pt = pt
                          iResult = SendMessage( hLVStyle, %LVM_HitTest, %Null, VarPtr(LVH))
                          If lvh.flags = %LVHT_OnItemStateIcon Then
                             temp$ = GetCompositeStyleString(iStyle)
                             Control Set Text hDlg, %IDC_StyleString, temp$
                             Control Set Text hDlg, %IDC_StyleValue,  "&H" + Hex$(iStyle)
                          End If
                  End Select
              Case %IDC_ListViewXStyle
                  Select Case Cb.NmCode
                      Case %LVN_ColumnClick
                          ClearCheckmarks(1)
                          temp$ = GetCompositeXStyleString(iXStyle)
                          Control Set Text hDlg, %IDC_XStyleString, temp$
                          Control Set Text hDlg, %IDC_XStyleValue,  "&H" + Hex$(iXStyle)
                      Case %LVN_ItemChanged
                          GetCursorPos PT
                          ScreenToClient hLVXStyle, PT
                          lvh.pt = pt
                          iResult = SendMessage( hLVXStyle, %LVM_HitTest, %Null, VarPtr(LVH))
                          If lvh.flags = %LVHT_OnItemStateIcon Then
                             temp$ = GetCompositeXStyleString(iXStyle)
                             Control Set Text hDlg, %IDC_XStyleString, temp$
                             Control Set Text hDlg, %IDC_XStyleValue,  "&H" + Hex$(iXStyle)
                          End If
                  End Select
          End Select
   End Select
End Function

Function ConvertStyleStringToLong(StyleString As String) As Long
    'convert String like "%BS_Left OR %BS_Center" Long
    'split string into array based on "OR" divider
    Local i, iLong As Long, iResult&, temp$
    StyleString = LCase$(StyleString)
    Dim SArray(ParseCount(StyleString,"or")-1) As String
    Parse StyleString, SArray(), " or "                    'splits string a$ at commas (default delimiter)
    For i = 0 To UBound(SArray)
        iResult = GetStylePosition(SArray(i))
        temp$ = StyleListName(iResult)
        iResult = StyleListValue(iResult)
        If i = 0 Then iLong = iResult Else iLong = (iLong Or iResult)
    Next i
    Function = iLong
End Function

Function ConvertXStyleStringToLong(xStyleString As String) As Long
    'convert String like "%BS_Left OR %BS_Center" Long
    'split string into array based on "OR" divider
    Local i, iLong As Long, iResult&, temp$
    xStyleString = LCase$(xStyleString)
    Dim SArray(ParseCount(xStyleString,"or")-1) As String
    Parse xStyleString, SArray(), " or "                    'splits string a$ at commas (default delimiter)
    For i = 0 To UBound(SArray)
        iResult = GetXStylePosition(SArray(i))
        temp$ = xStyleListName(iResult)
        iResult = xStyleListValue(iResult)
        If i = 0 Then iLong = iResult Else iLong = (iLong Or iResult)
    Next i
    Function = iLong
End Function

Function GetStylePosition(ByVal sWord As String) As Long
    'search for sWord$ in StyleList(), which is a Global array
    'return 1 if found, 0 otherwise
    'iPos& is UBound(StyleList) + 1 if searchterm > all values in array
    'iPos& is -1 if searchterm < all values in array
    'otherwise, iPos is position found, or position where search term should have been found (immediately below 1st item greater)
    Local Upper, Lower, iPos As Long
    Lower = LBound(StyleListName) : Upper = UBound(StyleListName)
    sWord = LCase$(sWord)

    'test boundary values
    If sWord = StyleListName(Lower) Then iPos = Lower : Function = 1 : Exit Function
    If sWord = StyleListName(Upper) Then iPos = Upper : Function = 1 : Exit Function
    If sWord < StyleListName(Lower) Then iPos = Lower - 1 : Function = 0 : Exit Function
    If sWord > StyleListName(Upper) Then iPos = Upper + 1 : Function = 0 : Exit Function

    Do Until (Upper <= (Lower+1))
        iPos& = (Lower + Upper) / 2
        Select Case sWord
           Case > StyleListName(iPos&) :  Lower = iPos
           Case < StyleListName(iPos&) :  Upper = iPos
           Case StyleListName(iPos&)   :  Function = iPos : Exit Function
        End Select
    Loop
    If iPos = -1 Then Function = 0 : Exit Function
    If iPos > UBound(StyleListName) Then Function = 0 : Exit Function
End Function

Function GetxStylePosition(ByVal sWord As String) As Long
    'search for sWord$ in StyleList(), which is a Global array
    'return 1 if found, 0 otherwise
    'iPos& is UBound(StyleList) + 1 if searchterm > all values in array
    'iPos& is -1 if searchterm < all values in array
    'otherwise, iPos is position found, or position where search term should have been found (immediately below 1st item greater)
    Local Upper, Lower, iPos As Long
    Lower = LBound(xStyleListName) : Upper = UBound(xStyleListName)
    sWord = LCase$(sWord)

    'test boundary values
    If sWord = xStyleListName(Lower) Then iPos = Lower : Function = 1 : Exit Function
    If sWord = xStyleListName(Upper) Then iPos = Upper : Function = 1 : Exit Function
    If sWord < xStyleListName(Lower) Then iPos = Lower - 1 : Function = 0 : Exit Function
    If sWord > xStyleListName(Upper) Then iPos = Upper + 1 : Function = 0 : Exit Function

    Do Until (Upper <= (Lower+1))
        iPos& = (Lower + Upper) / 2
        Select Case sWord
           Case > xStyleListName(iPos&) :  Lower = iPos
           Case < xStyleListName(iPos&) :  Upper = iPos
           Case xStyleListName(iPos&)   :  Function = iPos : Exit Function
        End Select
    Loop
    If iPos = -1 Then Function = 0 : Exit Function
    If iPos > UBound(xStyleListName) Then Function = 0 : Exit Function
End Function

Sub LoadStyleList
    Local temp$, sname As String, i, svalue, iMax, iCount, iCountX As Long
    'read the list from gbwinspy_styles.txt to get line count (must be pre-sorted)
    Open "gbwinspy_styles.txt" For Input As #1
    FileScan #1, Records To iMax
    Close #1

    'set array size to max possible value (will resize later)
    ReDim StyleListName(iMax), StyleListValue(iMax)
    ReDim xStyleListName(iMax), xStyleListValue(iMax)

    'read it again, for content
    Open "gbwinspy_styles.txt" For Input As #1
    iCount = 0 : iCountX = 0
    For i = 1 To iMax
       Line Input #1, temp$
       sname  = Trim$(Parse$(temp$,"=",1))
       svalue = Val(Parse$(temp$,"=",2))
       If InStr(sname, "_ex_") Then
          'xStyle
          Incr iCountX
          xStyleListName(iCountX) = sname
          xStyleListValue(iCountX) = svalue
          ListView Insert Item hDlg, %IDC_ListViewXStyle, iCountX, 0, sname
          ListView Set Text hDlg, %IDC_ListViewXStyle, iCountX, 2, "&H" + Hex$(svalue)
       Else
          'style
          Incr iCount
          StyleListName(iCount) = sname
          StyleListValue(iCount) = svalue
          ListView Insert Item hDlg, %IDC_ListViewStyle, iCount, 0, sname
          ListView Set Text hDlg, %IDC_ListViewStyle, iCount, 2, "&H" + Hex$(svalue)
       End If
    Next i
    Close #1
    ReDim Preserve StyleListName(iCount), StyleListValue(iCount)
    ReDim Preserve xStyleListName(iCountX), xStyleListValue(iCountX)
End Sub

Sub BuildMenu
   Menu New Bar To hMenu

   Menu New PopUp To hAction
   Menu Add PopUp, hMenu, "&Actions", hAction, %MF_Enabled
   Menu Add String, hAction, "Display Style String", %IDM_DisplayStyle, %MF_Enabled
   Menu Add String, hAction, "Display xStyle String", %IDM_DisplayXStyle, %MF_Enabled
   Menu Add String, hAction, "-", %IDM_Sep, 0
   Menu Add String, hAction, "Check Styles to Match Style String", %IDM_MatchStyles, %MF_Enabled
   Menu Add String, hAction, "Check xStyles to Match xStyle String", %IDM_MatchxStyles, %MF_Enabled
   Menu Add String, hAction, "-", %IDM_Sep, 0
   Menu Add String, hAction, "Clear Style Checkmarks", %IDM_ClearStyle, %MF_Enabled
   Menu Add String, hAction, "Clear xStyle Checkmarks", %IDM_ClearXStyle, %MF_Enabled
   Menu Add String, hAction, "Clear All Checkmarks", %IDM_ClearAll, %MF_Enabled

   Menu New PopUp To hControl
   Menu Add PopUp, hMenu, "&Settings", hControl, %MF_Enabled
     Menu Add String, hControl, cNames(400), %IDM_Dialog, %MF_Enabled
     Menu Add String, hControl, cNames(401), %IDM_Button, %MF_Enabled
     Menu Add String, hControl, cNames(402), %IDM_Check3State, %MF_Enabled
     Menu Add String, hControl, cNames(403), %IDM_CheckBox, %MF_Enabled
     Menu Add String, hControl, cNames(404), %IDM_ComboBox, %MF_Enabled
     Menu Add String, hControl, cNames(405), %IDM_Frame, %MF_Enabled
     Menu Add String, hControl, cNames(406), %IDM_Graphic, %MF_Enabled
     Menu Add String, hControl, cNames(407), %IDM_Image, %MF_Enabled
     Menu Add String, hControl, cNames(408), %IDM_ImageX, %MF_Enabled
     Menu Add String, hControl, cNames(409), %IDM_ImgButton, %MF_Enabled
     Menu Add String, hControl, cNames(410), %IDM_ImgButtonX, %MF_Enabled
     Menu Add String, hControl, cNames(411), %IDM_Label, %MF_Enabled
     Menu Add String, hControl, cNames(412), %IDM_Line, %MF_Enabled
     Menu Add String, hControl, cNames(413), %IDM_ListBox, %MF_Enabled
     Menu Add String, hControl, cNames(414), %IDM_ListView, %MF_Enabled
     Menu Add String, hControl, cNames(415), %IDM_Option, %MF_Enabled
     Menu Add String, hControl, cNames(416), %IDM_ProgressBar, %MF_Enabled
     Menu Add String, hControl, cNames(417), %IDM_HScrollBar, %MF_Enabled
     Menu Add String, hControl, cNames(418), %IDM_VScrollBar, %MF_Enabled
     Menu Add String, hControl, cNames(419), %IDM_StatusBar, %MF_Enabled
     Menu Add String, hControl, cNames(420), %IDM_Tab, %MF_Enabled
     Menu Add String, hControl, cNames(421), %IDM_TextBox, %MF_Enabled
     Menu Add String, hControl, cNames(422), %IDM_Toolbar, %MF_Enabled
     Menu Add String, hControl, cNames(423), %IDM_TreeView, %MF_Enabled

   Menu Attach hMenu, hDlg

     Menu New PopUp To hContext
     Menu Add String, hContext, "Cut",   %IDM_Cut,  %MF_Enabled
     Menu Add String, hContext, "Copy",  %IDM_Copy,  %MF_Enabled
     Menu Add String, hContext, "Paste", %IDM_Paste,  %MF_Enabled
     Menu Add String, hContext, "-", %IDM_Sep, 0
     Menu Add String, hContext, "Delete", %IDM_Delete,  %MF_Enabled

End Sub

Function GetCompositeStyleString(iStyle As Long) As String
    Local i, iPos, iResult, iCount As Long, stylestring$, temp$
    ListView Get Count hDlg, %IDC_ListViewStyle To iCount
    stylestring$ = "<empty>"
    For i = 1 To iCount
       iResult = ListView_GetCheckState(hLVStyle, i-1)
       If iResult Then
           ListView Get Text hDlg, %IDC_ListViewStyle, i,1 To temp$
           If iPos = 0 Then
               Incr iPos
               styleString$ = temp$
           Else
               styleString$ = styleSTring$ + " or " + temp$
           End If
       End If
    Next i
    iStyle = ConvertStyleStringToLong(stylestring$)
    Function = Trim$(stylestring$)
End Function

Function GetCompositeXStyleString(ixStyle As Long) As String
    Local i, iPos, iResult, iCount As Long, stylestring$, temp$
    ListView Get Count hDlg, %IDC_ListViewXStyle To iCount
    stylestring$ = "<empty>"
    For i = 1 To iCount
       iResult = ListView_GetCheckState(hLVXStyle, i-1)
       If iResult Then
           ListView Get Text hDlg, %IDC_ListViewXStyle, i,1 To temp$
           If iPos = 0 Then
               Incr iPos
               styleString$ = temp$
           Else
               styleString$ = styleSTring$ + " or " + temp$
           End If
       End If
    Next i
    ixStyle = ConvertXStyleStringToLong(stylestring$)
    Function = Trim$(stylestring$)
End Function

Sub Settings_INI(Task$)
   Local x,y As Long, INIFileName As Asciiz * %Max_Path
   Local xResult, yResult, tempAsciiZ As Asciiz * %Max_Path

   INIFileName = EXE.Path$ + "gbwinspy.ini"   'defines file name (any file name will work)

   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult$), Val(yResult$)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "500", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "400", yResult, %Max_Path, INIFileName
      Dialog Set Size hDlg,Val(xResult$), Val(yResult$)   'width/height

      'get string variables
'      Getprivateprofilestring "All", "CFN", "", tempAsciiZ, %Max_Path, INIFileName
'      CFN = tempAsciiZ

      'get numeric variables
      Getprivateprofilestring "All", "CurrentControlType", "401", tempAsciiZ, %Max_Path, INIFileName
      CurrentControlType = Val(tempAsciiZ)
      Menu Set State hControl, ByCmd CurrentControlType, 8
   End If

   If Task$ = "save" Then
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Size hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If

      'save string variables
'      tempASCIIZ = CFN
'      WritePrivateProfileString "All", "CFN", tempASCIIZ, INIFileName

      'save numeric variables
      tempASCIIZ = Str$(CurrentControlType)
      WritePrivateProfileString "All", "CurrentControlType", tempASCIIZ, INIFileName

   End If
End Sub

Sub ResizeWindow
    Local w,h As Long
    Dialog Get Client hDlg To w,h

    If w < 400 Then Exit Sub

    Control Set Loc hDlg, %IDC_ListViewXStyle, w/2+5, 65

    Control Set Size hDlg, %IDC_ListViewXStyle, w/2-15, h-75
    Control Set Size hDlg, %IDC_ListViewStyle, w/2-15, h-75

    ListView Set Column hDlg, %IDC_ListViewStyle, 1, w/2-15-80
    ListView Set Column hDlg, %IDC_ListViewXStyle, 1, w/2-15-80

    Control Set Loc hDlg, %IDC_StyleValue,w-100, 10
    Control Set Loc hDlg, %IDC_XStyleValue,w-100,  35

    Control Set Loc hDlg, %IDC_StringToHex, w-180,10
    Control Set Loc hDlg, %IDC_StringToXHex, w-180,35

    Control Set Loc Hdlg, %IDC_Convert, w-140,10
    Control Set Loc Hdlg, %IDC_xConvert, w-140,35

    Control Set Size hDlg, %IDC_StyleString, w-300,20
    Control Set Size hDlg, %IDC_XStyleString, w-300,20



    RedrawControls

End Sub

Sub RedrawControls
    Control ReDraw hDlg, %IDC_StyleValue
    Control ReDraw hDlg, %IDC_xStyleValue
    Control ReDraw hDlg, %IDC_StringToHex
    Control ReDraw hDlg, %IDC_StringToXHex
    Control ReDraw hDlg, %IDC_Convert
    Control ReDraw hDlg, %IDC_xConvert
    Control ReDraw hDlg, %IDC_StyleString
    Control ReDraw hDlg, %IDC_xStyleString
End Sub

Sub ClearCheckMarks(Flag As Long)
    Local i, iCount, iStyle, iXStyle As Long, temp$
    If Flag = 0 Or Flag = 2 Then
       ListView Get Count hDlg, %IDC_ListViewStyle To iCount
       For i = 1 To iCount
          ListView_SetCheckState(hLVStyle, i-1, %False)
       Next i
       temp$ = GetCompositeStyleString(iStyle)
       Control Set Text hDlg, %IDC_StyleString, temp$
       Control Set Text hDlg, %IDC_StyleValue,  "&H" + Hex$(iStyle)

    End If
    If Flag = 1 Or Flag = 2 Then
       ListView Get Count hDlg, %IDC_ListViewXStyle To iCount
       For i = 1 To iCount
          ListView_SetCheckState(hLVXStyle, i-1, %False)
       Next i
        temp$ = GetCompositeXStyleString(iXStyle)
        Control Set Text hDlg, %IDC_XStyleString, temp$
        Control Set Text hDlg, %IDC_XStyleValue,  "&H" + Hex$(iXStyle)
    End If
End Sub

Sub LoadcNames
    ReDim cNames(400 To 423), cPrefix(400 To 423)
    cNames(400) = "Dialog"       : cPrefix(400) = "ws_ ws_ex_ ds_"
    cNames(401) = "Button"       : cPrefix(401) = "ws_ ws_ex_ bs_"
    cNames(402) = "Check3State"  : cPrefix(402) = "ws_ ws_ex_ bs_"
    cNames(403) = "CheckBox"     : cPrefix(403) = "ws_ ws_ex_ bs_"
    cNames(404) = "ComboBox"     : cPrefix(404) = "ws_ ws_ex_ cbs_"
    cNames(405) = "Frame"        : cPrefix(405) = "ws_ ws_ex_ bs_"
    cNames(406) = "Graphic"      : cPrefix(406) = "ws_ ws_ex_ ss_"
    cNames(407) = "Image"        : cPrefix(407) = "ws_ ws_ex_ ss_"
    cNames(408) = "ImageX"       : cPrefix(408) = "ws_ ws_ex_ ss_"
    cNames(409) = "ImgButton"    : cPrefix(409) = "ws_ ws_ex_ bs_"
    cNames(410) = "ImgButtonX"   : cPrefix(410) = "ws_ ws_ex_ bs_"
    cNames(411) = "Label"        : cPrefix(411) = "ws_ ws_ex_ ss_"
    cNames(412) = "Line"         : cPrefix(412) = "ws_ ws_ex_ ss_"
    cNames(413) = "ListBox"      : cPrefix(413) = "ws_ ws_ex_ lbs_"
    cNames(414) = "ListView"     : cPrefix(414) = "ws_ ws_ex_ lvs_ lvs_ex_"
    cNames(415) = "Option"       : cPrefix(415) = "ws_ ws_ex_ bs_"
    cNames(416) = "ProgressBar"  : cPrefix(416) = "ws_ ws_ex_ pbs_"
    cNames(417) = "HScrollBar"   : cPrefix(417) = "ws_ ws_ex_ sbars_"
    cNames(418) = "VScrollBar"   : cPrefix(418) = "ws_ ws_ex_ sbars_"
    cNames(419) = "StatusBar"    : cPrefix(419) = "ws_ ws_ex_ sbs_"
    cNames(420) = "TAB"          : cPrefix(420) = "ws_ ws_ex_ ss_"
    cNames(421) = "TextBox"      : cPrefix(421) = "ws_ ws_ex_ es_"
    cNames(422) = "Toolbar"      : cPrefix(422) = "ws_ ws_ex_ tbstyle_"
    cNames(423) = "TreeView"     : cPrefix(423) = "ws_ ws_ex_ tvs_"
End Sub

Sub BuildControls
  Control Add ImgButton, hDlg, %IDC_Spy, "spy", 10,12,32,32

  Control Add Label, hDlg, %IDC_LabelStyle, "Style:", 50,10,50,20, %SS_Left Or %SS_Notify
  Control Add TextBox, hDlg,%IDC_StyleString, "<style string>", 110,10,360,20
  Control Add Button, hDlg,%IDC_StringToHex, "--->",440,10,30,20
  Control Add Button, hDlg,%IDC_Convert, "<---",480,10,30,20
  Control Add TextBox, hDlg,%IDC_StyleValue, "<style value>", 521,10,90,20

  Control Add Label, hDlg, %IDC_LabelXStyle, "Ext. Style:", 50,35,50,20, %SS_Left Or %SS_Notify
  Control Add TextBox, hDlg,%IDC_xStyleString, "<style string>", 110,35,360,20
  Control Add Button, hDlg,%IDC_StringToXHex, "--->",440,35,30,20
  Control Add Button, hDlg,%IDC_xConvert, "<---",480,35,30,20
  Control Add TextBox, hDlg,%IDC_xStyleValue, "<style value>", 520,35,90,20

  Control Add ListView, hDlg, %IDC_ListViewStyle, "",10,65,270,350  ', %WS_TabStop Or %LVS_Report
    Control Handle hDlg, %IDC_ListViewStyle To hLVStyle
    ListView Insert Column hDlg, %IDC_ListViewStyle, 1, "Style", 180, 0
    ListView Insert Column hDlg, %IDC_ListViewStyle, 2, "Value", 80, 0
    ListView Set StyleXX hDlg, %IDC_ListViewStyle, %LVS_Ex_CheckBoxes Or %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect

  Control Add ListView, hDlg, %IDC_ListViewXStyle, "",300,65,270,350  ', %WS_TabStop Or %LVS_Report
    Control Handle hDlg, %IDC_ListViewXStyle To hLVXStyle
    ListView Insert Column hDlg, %IDC_ListViewXStyle, 1, "ExtStyle", 180, 0
    ListView Insert Column hDlg, %IDC_ListViewXStyle, 2, "Value", 80, 0
    ListView Set StyleXX hDlg, %IDC_ListViewXStyle, %LVS_Ex_CheckBoxes Or %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect


    Control Handle hDlg, %IDC_StyleString To hTB1
    Control Handle hDlg, %IDC_xStyleString To hTB2
    Control Handle hDlg, %IDC_StyleValue To hTB3
    Control Handle hDlg, %IDC_xStyleValue To hTB4

    OP1 = SetWindowLong(hTB1, %GWL_WndProc, CodePtr(NewProc))  'subclass
    OP2 = SetWindowLong(hTB2, %GWL_WndProc, CodePtr(NewProc))  'subclass
    OP3 = SetWindowLong(hTB3, %GWL_WndProc, CodePtr(NewProc))  'subclass
    OP4 = SetWindowLong(hTB4, %GWL_WndProc, CodePtr(NewProc))  'subclass
End Sub

Function NewProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x,y As Long
   Select Case Msg
      Case %WM_ContextMenu
         hCurrentTextBox = hWnd
         x = Lo(Word,lParam) : y = Hi(Word, lParam)    'WM_ContextMenu returns xy coordinates of mouse
         TrackPopupMenu hContext, %TPM_LEFTALIGN, x, y, 0, hDlg, ByVal 0   'put context menu where mouse is
         Function = 0 : Exit Function
   End Select
   If hWnd = hTB1 Then Function = CallWindowProc(OP1, hWnd, Msg, wParam, lParam)
   If hWnd = hTB2 Then Function = CallWindowProc(OP2, hWnd, Msg, wParam, lParam)
   If hWnd = hTB3 Then Function = CallWindowProc(OP3, hWnd, Msg, wParam, lParam)
   If hWnd = hTB4 Then Function = CallWindowProc(OP4, hWnd, Msg, wParam, lParam)
End Function

Sub CreateToolTips
      Local TI As TOOLINFO, TipText As Asciiz * %Max_Path, hToolTip As Dword
      hToolTip = CreateWindowEx(ByVal 0, "tooltips_class32", "", %TTS_ALWAYSTIP,  _
           0, 0, 0, 0, ByVal hDlg, ByVal 0, GetModuleHandle(ByVal %NULL), ByVal 0)
      TipText = "Convert Style String to Hex"
      TI.cbSize    = Len(TI)
      TI.uFlags    = %TTF_SUBCLASS Or %TTF_IDISHWND
      TI.hWnd      = GetParent(hToolTip)
      TI.uId       = GetDlgItem(hDlg,%IDC_StringToHex)
      TI.lpszText  = VarPtr(TipText)
      SendMessage hToolTip, %TTM_ADDTOOL, 0, VarPtr(ti)

      TipText = "Convert Ext Style String to Hex"
      TI.uId       = GetDlgItem(hDlg,%IDC_StringToXHex)
      SendMessage hToolTip, %TTM_ADDTOOL, 0, VarPtr(ti)

      TipText = "Convert Style Hex to String (based on Control Setting)"
      TI.uId       = GetDlgItem(hDlg,%IDC_Convert)
      SendMessage hToolTip, %TTM_ADDTOOL, 0, VarPtr(ti)

      TipText = "Convert Ext Style Hex to String (based on Control Setting)"
      TI.uId       = GetDlgItem(hDlg,%IDC_xConvert)
      SendMessage hToolTip, %TTM_ADDTOOL, 0, VarPtr(ti)
End Sub

Sub MatchStyles
    Local i, iPos, iResult, iCount As Long, StyleString As String, temp$
    ListView Get Count hDlg, %IDC_ListViewStyle To iCount

    Control Get Text hDlg, %IDC_StyleString To StyleString
    StyleString = LCase$(StyleString)

    Dim SArray(ParseCount(StyleString,"or")-1) As String
    Parse StyleString, SArray(), " or "                    'splits string a$ at commas (default delimiter)

    ClearCheckMarks(0)

    For i = 1 To iCount
       ListView Get Text hDlg, %IDC_ListViewStyle, i,1 To temp$
       If InStr(StyleString,temp$) Then ListView_SetCheckState(hLVStyle, i-1, %True)
    Next i
End Sub

Sub MatchXStyles
    Local i, iPos, iResult, iCount As Long, xStyleString As String, temp$
    ListView Get Count hDlg, %IDC_ListViewXStyle To iCount

    Control Get Text hDlg, %IDC_xStyleString To xStyleString
    xStyleString = LCase$(xStyleString)

    Dim SArray(ParseCount(xStyleString,"or")-1) As String
    Parse xStyleString, SArray(), " or "                    'splits string a$ at commas (default delimiter)

    ClearCheckMarks(1)

    For i = 1 To iCount
       ListView Get Text hDlg, %IDC_ListViewxStyle, i,1 To temp$
       If InStr(xStyleString,temp$) Then ListView_SetCheckState(hLVXStyle, i-1, %True)
    Next i
End Sub

Sub ConvertStyleLongToString(StyleString As String)
    Local i, iPos, iResult, iCount, iStyleString As Long, P, S As String, temp$, pre$

    P = cPrefix(CurrentControlType)    'P is just to minimize typing
    iStyleString = Val(StyleString)

    ListView Get Count hDlg, %IDC_ListViewStyle To iCount
    For i = 1 To iCount
       ListView Get Text hDlg, %IDC_ListViewStyle, i,1 To temp$
       iPos = InStr(-1,temp$,"_")
       pre$ = Mid$(temp$,2,iPos-1)
       If InStr(P, pre$) Then  'get just the prefix part of temp$
           'use the style for testing
           If LongTest(temp$,iStyleString) Then 'is temp$ found in iStyleString
               S = S + $CrLf + temp$
           End If
       End If
    Next i
    ? S
End Sub

Sub ConvertXStyleLongToString(xStyleString As String)
    Local i, iPos, iResult, iCount, ixStyleString As Long, P, S As String, temp$, pre$

    P = cPrefix(CurrentControlType)    'P is just to minimize typing
    ixStyleString = Val(xStyleString)

    ListView Get Count hDlg, %IDC_ListViewXStyle To iCount
    For i = 1 To iCount
       ListView Get Text hDlg, %IDC_ListViewxStyle, i,1 To temp$
       iPos = InStr(-1,temp$,"_")
       pre$ = Mid$(temp$,2,iPos-1)
       If InStr(P, pre$) Then  'get just the prefix part of temp$
           'use the style for testing
           If LongTest(temp$,ixStyleString) Then  'is temp$ found in iStyleString
               S = S + $CrLf + temp$
           End If
       End If
    Next i
    ? S
End Sub

Function LongTest(StyleString As String, StyleValue As Long) As Long
   Function = 1
End Function
